#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <allegro.h>
#include "data1.h"

int sine[64];
BITMAP *buffer1;
PALLETE pal;
DATAFILE *data;

unsigned char dbuffer[64000];
unsigned char bmap[64000];

void initialise_allegro()
{ 
 allegro_init(); 
 set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0);
 buffer1=create_bitmap(320,200);
 set_palette(pal); 
 install_keyboard();
 install_timer();
 data=load_datafile("data1.dat");
 set_palette(data[pal1].dat);
}

void CalcTables()
{
 int i;
   /* Pre-calculate the sin(something)*10 */
   for (i=0;i<64;i++)
   {
      sine[i]=(sin(i*(6.28318531/64))*8);
   }
}

void DrawWave(int d1,int d2)
{
   int offs=0, y, x;
   for (y=0;y<200;y++)
      for (x=0;x<320;x++)
      {
         dbuffer[offs++]=bmap[offs+sine[(x+d1)&63]+(sine[(y+d2)&63])+(sine[(y+d2)&63])];
      }
      memcpy(buffer1->line[0], dbuffer, 64000);
//      vsync();
      blit(buffer1, screen, 0, 0, 0, 0, 320, 200);

}

void main()
{

    int delta1, delta2;

    initialise_allegro();
    CalcTables();
    blit(data[hmap1].dat, buffer1, 0, 0, 0, 0, 320, 200);
    memcpy(bmap, buffer1->line[0], 64000);
    blit(buffer1, screen,0,0,0,0,320,200);
    textout(screen, font,"Space bar to begin, Esc Quits",0,170, 250);
    while(!key[KEY_SPACE]);
    delta2=1;
    while(!key[KEY_ESC])
    {
     DrawWave(0,delta2);
     delta2++;
     if (delta2>320) delta2=1;
    }
    exit(0);
}
